<template>
  <!-- 列表 -->
  <ContentWrap>
    <!-- <el-button type="primary" plain @click="openForm('create')" v-hasPermi="['system:tenant-balance:create']">
      <Icon icon="ep:plus" class="mr-5px" /> 新增
    </el-button> -->
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <!-- <el-table-column label="主键" align="center" prop="id" /> -->
      <el-table-column label="金额" align="center" prop="points" />
      <el-table-column label="变动后余额" align="center" prop="balance" />
      <el-table-column label="类型" align="center" prop="type" />
      <el-table-column label="描述" align="center" prop="description" />
      <el-table-column label="订单 Id/业务单号" align="center" prop="orderId" />
      <el-table-column label="业务流水号" align="center" prop="bizNo" />
      <el-table-column label="操作人 Id" align="center" prop="operatorId" />
      <el-table-column label="目标租户Id" align="center" prop="targetTenantId" />
      <el-table-column label="创建时间" align="center" prop="createdAt" :formatter="dateFormatter" width="180px" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center">
        <template #default="scope">
          <el-button link type="primary" @click="openForm('update', scope.row.id)"
            v-hasPermi="['system:tenant-balance:update']">
            编辑
          </el-button>
          <el-button link type="danger" @click="handleDelete(scope.row.id)"
            v-hasPermi="['system:tenant-balance:delete']">
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination :total="total" v-model:page="queryParams.pageNo" v-model:limit="queryParams.pageSize"
      @pagination="getList" />
  </ContentWrap>
  <!-- 表单弹窗：添加/修改 -->
  <TenantPointsForm ref="formRef" @success="getList" />
</template>
<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import { TenantBalanceApi } from '@/api/system/tenantbalance'
import TenantPointsForm from './TenantPointsForm.vue'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const props = defineProps<{
  tenantId?: number // 租户 Id（主表的关联字段）
}>()
const loading = ref(false) // 列表的加载中
const list = ref([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  tenantId: undefined as unknown
})

/** 监听主表的关联字段的变化，加载对应的子表数据 */
watch(
  () => props.tenantId,
  (val: number) => {
    if (!val) {
      return
    }
    queryParams.tenantId = val
    handleQuery()
  },
  { immediate: true, deep: true }
)

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await TenantBalanceApi.getTenantPointsPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  if (!props.tenantId) {
    message.error('请选择一个租户余额')
    return
  }
  formRef.value.open(type, id, props.tenantId)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await TenantBalanceApi.deleteTenantPoints(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch { }
}
</script>